#include "spawn.h"

#include "..\algorithms.h"

void botInfo::gotHelp(Player *p, Command *c)
{
	// List commands

	if (!*c->final)
	{
		switch (p->access)
		{
		case OP_Duke:
		case OP_Baron:
		case OP_King:
		case OP_Emperor:
		case OP_RockStar:
		case OP_Q:
		case OP_God:
		case OP_Owner:
			{	// Owner-level commands
			}
		case OP_SysOp:
			{	// SysOp-level commands
				sendPrivate(p,"-Log Bot: !playerlog <PlayerName> !datelog <mm/dd/yy> !textlog <text>");
				sendPrivate(p,"-Log Bot: !pagelog <Page#> !lastlog <#> !clearlog");
				break;
			}
		case OP_SuperModerator:
			{	// SuperModerator-level commands
//				sendPrivate(p, "Ext: ");
			}
		case OP_Moderator:
			{	// Moderator-level commands
//				sendPrivate(p, "Ext: ");
			}
		case OP_Limited:
			{	// Limited-level commands
			}
		case OP_Player:
			{	// Player-level commands
			}
		}

		return;
	}

	// Specific command help

	switch (p->access)
	{
	case OP_Duke:
	case OP_Baron:
	case OP_King:
	case OP_Emperor:
	case OP_RockStar:
	case OP_Q:
	case OP_God:
	case OP_Owner:
		{	// Owner-level commands
		}
	case OP_SysOp:
		{	// SysOp-level commands
			if(c->checkParam("playerlog"))
			{sendPrivate(p,"Command !playerlog <Name>: Will search and print out the log of anything that <name> said to the bot");}
			else if(c->checkParam("datelog"))
			{sendPrivate(p,"Command !datelog <mm/dd/yy>: Searches for a specific date and displays the log from that date");}
			else if(c->checkParam("textlog"))
			{sendPrivate(p,"Command !textlog <text>: Searches for something specific that someone said to the bot");}
			else if(c->checkParam("pagelog"))
			{sendPrivate(p,"Command !pagelog <page#>: Browse through the entire log, each page will print out no more than 50 lines of the log");}
			else if(c->checkParam("lastlog"))
			{sendPrivate(p,"Command !lastlog <#>: Prints out the last # of lines from the log, Ex- !lastlog 5 would print the last 5 things in the log");}
			else if(c->checkParam("clearlog"))
			{sendPrivate(p,"Command !clearlog: Clears the log completely");}
			break;
		}
	case OP_SuperModerator:
		{	// SuperModerator-level commands
		}
	case OP_Moderator:
		{	// Moderator-level commands
		}
	case OP_Limited:
		{	// Limited-level commands
		}
	case OP_Player:
		{	// Player-level commands
		}
	}
}

void botInfo::gotCommand(Player *p, Command *c)
{
	if (!p) return;
	if (!c) return;

	switch (p->access)
	{
	case OP_Duke:
	case OP_Baron:
	case OP_King:
	case OP_Emperor:
	case OP_RockStar:
	case OP_Q:
	case OP_God:
		
	case OP_Owner:
		{
			
		}
	case OP_SysOp:
		{	// SysOp-level commands
			if(c->check("playerlog"))
			{	
				if(c->final[0])
				{
					ifstream infile(LogName.msg,ios::in);
					char Line[100];
					bool Found=false;
					String Name;

					while(infile.good())
					{
						infile.getline(Line,100,'\n');
						Name=Line+20;
						Name=Name.split('>');

						if(Line[0] && CMPSTR(Name,c->final))
						{
							Found=true;
							sendPrivate(p,Line);
						}
					}
					infile.close();

					if(!Found)
					{sendPrivate(p,"That player was not found in the log");}
				}
				else
				{sendPrivate(p,"You must specify a name, Format: !playerlog <PlayerName>");}

			}
			else if(c->check("clearlog"))
			{
				ofstream clearfile(LogName.msg,ios::out);
				clearfile.close();
				sendPrivate(p,"Log Cleared");
			}
			else if(c->check("datelog"))
			{
				if(c->final[0])
				{
					for(Uint16 i=0;c->final[i]!='\0';i++)
					{
						if(c->final[i]=='-')
						{c->final[i]='/';}
					}

					if(i==8)
					{
						ifstream infile(LogName.msg,ios::in);
						char Line[100];
						bool Found=false;

						while(infile.good())
						{
							infile.getline(Line,100,'\n');
							
							if(Line[0] && CMPSTART(c->final,Line))
							{
								Found=true;
								sendPrivate(p,Line);
							}
						}
						infile.close();

						if(!Found)
						{sendPrivate(p,"That date was not found in the log");}
					}
					else
					{sendPrivate(p,"Date must contain 8 digits, Format: !datelog <mm/dd/yy>");}
				}
				else
				{sendPrivate(p,"You must specify a date, Format: !datelog <mm/dd/yy>");}
			}
			else if(c->check("textlog"))
			{
				if(c->final[0])
				{
					tolower(c->final);
					ifstream infile(LogName.msg,ios::in);
					char Line[100];
					bool Found=false;
					String Text;

					while(infile.good())
					{
						infile.getline(Line,100,'\n');

						Text=Line;
						Text.split('>');
						Text.lcase();

						if(Line[0] && strInstanceOf(Text.msg,c->final))
						{
							Found=true;
							sendPrivate(p,Line);
						}
					}
					infile.close();

					if(!Found)
					{sendPrivate(p,"That text was not found in the log");}
				}
				else
				{sendPrivate(p,"You must specify text, Format: !textlog <text>");}
			}
			else if(c->check("pagelog"))
			{
				String Message;
				Uint32 PageCount=LineCount();
				PageCount=PageCount/50 + (PageCount%50>0);

				if(isNumeric(c->final))
				{
					ifstream infile(LogName.msg,ios::in);
					char Line[100];
					Uint16 Page=getInteger(c->final,10);
					Uint16 i=(Page-1)*50;

					while(i>0 && infile.good())
					{
						if(infile.get()=='\n')
						{i--;}
					}

					if(i==0)
					{
						Message="--------- Page# ";
						Message+=Page;
						Message+=" of ";
						Message+=PageCount;
						Message+=" Pages ---------";
						sendPrivate(p,Message);
						while(infile.good() && i<50)
						{
							i++;
							infile.getline(Line,100,'\n');
							if(Line[0])
							{sendPrivate(p,Line);}
						}
					}
					else
					{sendPrivate(p,"That page does not exist, use a smaller number");}

					infile.close();
				}
				else
				{
					Message="There are a total of ";
					Message+=PageCount;
					Message+=" pages in the log. Format- !pagelog <Page#>";
					sendPrivate(p,Message);
				}
			}
			else if(c->check("lastlog"))
			{
				if(isNumeric(c->final))
				{
					Uint32 TotalLines=LineCount();
					Uint32 i=getInteger(c->final,10);
					if(TotalLines-i>0)
					{
						ifstream infile(LogName.msg,ios::in);
						char Line[100];
						i=TotalLines-i;

						while(i>0 && infile.good())
						{
							if(infile.get()=='\n')
							{i--;}
						}

						while(infile.good())
						{
							infile.getline(Line,100,'\n');
							if(Line[0])
							{sendPrivate(p,Line);}
						}

						infile.close();
					}
					else
					{sendPrivate(p,"There are not that many previous messages in the log");}
				}
				else
				{sendPrivate(p,"You must specify a number, Format- !lastlog <#>");}
			}
		}
	case OP_SuperModerator:
		{	// SuperModerator-level commands
		}
	case OP_Moderator:
		{	// Moderator-level commands
			
		}
	case OP_Limited:
		{	// Limited-level commands
		}
	case OP_Player:
		{	// Player-level commands
			if (c->check("about") || c->check("version"))
			{
				sendPrivate(p, "LogBot by 50% Packetloss (FiftyPacketloss@socal.rr.com)");
			}
		}
	}
	
	if(OnlyMods && p->access<=OP_Player)
	{goto Skip;}

	for(el=ExemptList.head;el;el=el->next)
	{
		if(CMPSTR(el->item->name,p->name))
		{goto Skip;}
	}

	for(wl=IgnoreWordList.head;wl;wl=wl->next)
	{
		if(c->check(wl->item->theWord))
		{goto Skip;}

	}

	outfile.open(LogName.msg,ios::app);
	if(outfile.good())
	{
		if(time(&theTime)!=-1)
		{
			TimeStruct=localtime(&theTime);
			strftime(date, 21,"%c : ",TimeStruct);
			outfile << date << p->name << "> !";

			if(STRLEN(c->cmd)>20)
			{outfile << String(c->cmd,20);}
			else
			{outfile << c->cmd;}

			outfile << " ";
	
			if(STRLEN(c->final)>30)
			{outfile << String(c->final,30);}
			else
			{outfile << c->final;}

			outfile << endl;
		}
	}
	outfile.close();
	
Skip:
	{}
}

void botInfo::gotRemoteHelp(char *p, Command *c, Operator_Level l)
{
	// List commands

	if (!*c->final)
	{
		switch (l)
		{
		case OP_Duke:
		case OP_Baron:
		case OP_King:
		case OP_Emperor:
		case OP_RockStar:
		case OP_Q:
		case OP_God:
		case OP_Owner:
			{	// Owner-level commands
			}
		case OP_SysOp:
			{	// SysOp-level commands
			}
		case OP_SuperModerator:
			{	// SuperModerator-level commands
			}
		case OP_Moderator:
			{	// Moderator-level commands
			}
		case OP_Limited:
			{	// Limited-level commands
			}
		case OP_Player:
			{	// Player-level commands
			}
		}

		return;
	}

	// Specific command help

	switch (l)
	{
	case OP_Duke:
	case OP_Baron:
	case OP_King:
	case OP_Emperor:
	case OP_RockStar:
	case OP_Q:
	case OP_God:
	case OP_Owner:
		{	// Owner-level commands
		}
	case OP_SysOp:
		{	// SysOp-level commands
		}
	case OP_SuperModerator:
		{	// SuperModerator-level commands
		}
	case OP_Moderator:
		{	// Moderator-level commands
		}
	case OP_Limited:
		{	// Limited-level commands
		}
	case OP_Player:
		{	// Player-level commands
		}
	}
}

void botInfo::gotRemote(char *p, Command *c, Operator_Level l)
{
	if (!c) return;

	switch (l)
	{
	case OP_Duke:
	case OP_Baron:
	case OP_King:
	case OP_Emperor:
	case OP_RockStar:
	case OP_Q:
	case OP_God:
	case OP_Owner:
		{	// Owner-level commands
		}
	case OP_SysOp:
		{	// SysOp-level commands
		}
	case OP_SuperModerator:
		{	// SuperModerator-level commands
		}
	case OP_Moderator:
		{	// Moderator-level commands
		}
	case OP_Limited:
		{	// Limited-level commands
		}
	case OP_Player:
		{	// Player-level commands
		}
	}
}
